
%define build_cross %{?cross_target:1}%{!?cross_target:0}
%define cross_prefix %{?cross_target:cross-%{cross_target}-}
%if %{build_cross}
%define fpc_target %{cross_target}
%else
%define fpc_target %_arch
%endif
%if %{fpc_target} == ppc
%define fpc_target powerpc
%endif
%define fpc_short_target %_target_cpu
%if %{fpc_short_target} == x86_64
%define fpc_short_target x64
%endif
%if %{fpc_short_target} == i586
%define fpc_short_target 386
%endif

%define name fpc
%define version 2.6.4
%define release %mkrel 1
%define fpcversion %{version}
%define fpcdir %{_prefix}/lib/%{name}/%{fpcversion}
%define docdir %{_datadir}/doc/fpc-%{fpcversion}

%define builddocdir %{buildroot}%{docdir}
%define buildmandir %{buildroot}%{_datadir}
%define buildbindir %{buildroot}%{_bindir}
%define buildlibdir %{buildroot}%{_libdir}
%define buildexampledir %{builddocdir}/examples


Name: 		%{name}
Version: 	%{version}
Release: 	%{release}
ExclusiveArch: 	%{ix86} ppc x86_64
License: 	GPLv2+ and LGPLv2+ with exceptions
Group: 		Development/Other
Source:		http://surfnet.dl.sourceforge.net/sourceforge/freepascal/%{name}-%{version}.source.tar.xz
Source2:        fpc.cft
Source3:        fppkg.cfg
Source4:        default.cft
Patch0:         fpc-2.6.2-r22920.patch
Summary: 	Free Pascal Compiler
Summary(de):	Freier Pascal Compiler 
URL: 		http://www.freepascal.org/
Requires:	gcc
BuildRequires:  fpc
BuildRequires: 	texlive mysql-devel postgresql-devel
%if %{build_cross}
BuildRequires:	cross-%{cross_target}-binutils
%endif

%description	
The Free Pascal Compiler is a Turbo Pascal 7.0 and Delphi compatible 32bit
Pascal Compiler. It comes with fully TP 7.0 compatible run-time library.
Some extensions are added to the language, like function overloading. Shared
libraries can be linked. Basic Delphi support is already implemented (classes,
exceptions,ansistrings,RTTI). This package contains commandline compiler and
utils. Provided units are the runtime library (RTL), free component library
(FCL), gtk,ncurses,zlib, mysql,postgres,ibase bindings.

#german
%description -l de
Freepascal ist ein freier 2/64bit Pascal Compiler. Er kommt mit einer 
Run-time-Bibliothek die voll kompatibel zu Turbo Pascal 7.0 und nahezu 
kompatibel zu Delphi ist.Viele Erweiterungen wurden den Sprachen hinzu 
gefügt, wie überladene Funktionen. Auf geteilte Bibliotheken kann verwiesen 
werden. Das Paket enthält Kommandozeilen Compiler und Werkzeuge. Unterstützt 
werden runtime library (RTL), free component library(FCL) und Bindungen für 
viele anderen gtk1, gtk2, ncurses, zlib, mysql, postgres und ibase. 

%package src
Summary:	Source code of Free Pascal Compiler
Summary(de):	Free Pascal Compiler - Sources 
Group:		Development/Libraries

%description src
The source code of Freepascal for documentation and code generation
purposes.

#german
%description src -l de
Das Fpc-src Paket enthält die Sources von Freepascal, zur Dokumentation 
oder zum Zweck der automatischen Erstellung. 

%prep
%setup -q
%patch0 -p1

%if "%(rpm -q --qf '%%{version}' fpc 2>/dev/null)" == "2.1.1"
cp -a rtl/linux/Makefile rtl/linux/Makefile.real
perl -pi -e "s, fmtbcd , ," rtl/linux/Makefile
perl -pi -e "s,if FPC_PATCH<2,ifdef FOOMDV," compiler/pp.pas
%endif

%build
mkdir -p fpc_src
cp -a rtl packages fpc_src
rm -rf fpc_src/packages/extra/amunits
rm -rf fpc_src/packages/extra/winunits
find $RPM_BUILD_DIR/%{name}-%{version} -name *.ppu -delete


%if %{build_cross}
fpcmake -T%{fpc_target}-linux
%endif

%if %{build_cross}
EXTRA_FLAGS="CPU_TARGET=%{fpc_target} BINUTILSPREFIX=%{cross_target}-linux-"
NEWPP=`pwd`/compiler/ppcross%{fpc_short_target}
%else
EXTRA_FLAGS=
NEWPP=`pwd`/compiler/ppc%{fpc_short_target}
%endif
NEWFPDOC=`pwd`/utils/fpdoc/fpdoc
	make compiler_cycle ${EXTRA_FLAGS} \
%if "%(rpm -q --qf '%%{version}' fpc 2>/dev/null)" == "2.1.1"
		FPC="fpc -dVER2_0" \
%ifarch %ix86
		TARGET_LOADERS="prt0 dllprt0 cprt0 gprt0"
%endif
#
	cp -af rtl/linux/Makefile.real rtl/linux/Makefile
	cp -a ${NEWPP} bootstrapmdvfpc
	make compiler_cycle ${EXTRA_FLAGS} FPC=$(pwd)/bootstrapmdvfpc
%endif
#
	make rtl_clean rtl_smart FPC=${NEWPP} ${EXTRA_FLAGS}
	make packages_smart FPC=${NEWPP} ${EXTRA_FLAGS}
	make ide_all FPC=${NEWPP} ${EXTRA_FLAGS}
	make utils_all FPC=${NEWPP} ${EXTRA_FLAGS}

%install
rm -Rf %{buildroot}
%if %{build_cross}
EXTRA_FLAGS="CPU_TARGET=%{fpc_target} BINUTILSPREFIX=%{cross_target}-linux-"
NEWPP=`pwd`/compiler/ppcross%{fpc_short_target}
NEWFCPMAKE=/usr/bin/fpcmake
%else
EXTRA_FLAGS=
NEWPP=`pwd`/compiler/ppc%{fpc_short_target}
NEWFCPMAKE=`pwd`//utils/fpcm/fpcmake
%endif
INSTALLOPTS="FPC=${NEWPP} INSTALL_PREFIX=%{buildroot}/%{_prefix} INSTALL_LIBDIR=%{buildlibdir} \
                INSTALL_DOCDIR=%{builddocdir} INSTALL_BINDIR=%{buildbindir}"
	make compiler_distinstall ${INSTALLOPTS} FPCMAKE=${NEWFCPMAKE} ${EXTRA_FLAGS}
	make rtl_distinstall ${INSTALLOPTS} FPCMAKE=${NEWFCPMAKE} ${EXTRA_FLAGS}
	make packages_distinstall ${INSTALLOPTS} FPCMAKE=${NEWFCPMAKE} ${EXTRA_FLAGS}
	make ide_distinstall ${INSTALLOPTS} FPCMAKE=${NEWFCPMAKE} ${EXTRA_FLAGS}
	make utils_distinstall ${INSTALLOPTS} FPCMAKE=${NEWFCPMAKE} ${EXTRA_FLAGS}

%if %{build_cross}
	rm -rf %{buildexampledir}
%else
%endif

ln -sf %{fpcdir}/ppc%{fpc_short_target} %{buildroot}%{_bindir}/ppc%{fpc_short_target}

# Create a version independent compiler-configuration file with build-id
# enabled by default
# For this purpose some non-default templates are used. So the samplecfg
# script could not be used and fpcmkcfg is called directly.
%{buildroot}%{_bindir}/fpcmkcfg -p -t %{SOURCE2} -d "basepath=%{_exec_prefix}" -o %{buildroot}%{_sysconfdir}/fpc.cfg
# Create the IDE configuration files
%{buildroot}%{_bindir}/fpcmkcfg -p -1 -d "basepath=%{_prefix}/lib/%{name}/\$fpcversion" -o %{buildroot}%{_prefix}/lib/%{name}/%{version}/ide/text/fp.cfg
%{buildroot}%{_bindir}/fpcmkcfg -p -2 -o %{buildroot}%{_prefix}/lib/%{name}/%{version}/ide/text/fp.ini
# Create the fppkg configuration files
%{buildroot}%{_bindir}/fpcmkcfg -p -t %{SOURCE3} -d CompilerConfigDir=%{_sysconfdir}/fppkg -d arch=%{_arch} -o %{buildroot}%{_sysconfdir}/fppkg.cfg
%{buildroot}%{_bindir}/fpcmkcfg -p -t %{SOURCE4} -d fpcbin=%{_bindir}/fpc -d GlobalPrefix=%{_exec_prefix} -d lib=lib -o %{buildroot}%{_sysconfdir}/fppkg/default_%{_arch}

# Include the COPYING-information for the compiler/rtl/fcl in the documentation
cp -a compiler/COPYING.txt %{buildroot}%{_defaultdocdir}/%{name}-%{version}/COPYING
cp -a rtl/COPYING.txt %{buildroot}%{_defaultdocdir}/%{name}-%{version}/COPYING.rtl
cp -a rtl/COPYING.FPC %{buildroot}%{_defaultdocdir}/%{name}-%{version}/COPYING.FPC

# The source-files:
mkdir -p %{buildroot}%{_datadir}/fpcsrc
cp -a fpc_src/* %{buildroot}%{_datadir}/fpcsrc/


%clean
rm -rf $RPM_BUILD_ROOT
	
%post
# Create config
%{fpcdir}/samplecfg %{fpcdir}

%files
%doc %{_defaultdocdir}/%{name}-%{version}
%{_bindir}/*
%{_prefix}/lib/fpc
%config(noreplace) %{_sysconfdir}/%{name}.cfg
%config(noreplace) %{_sysconfdir}/fppkg.cfg
%config(noreplace) %{_sysconfdir}/fppkg/default_%{_arch}

%files src
%{_datadir}/fpcsrc


%changelog
* Sat Sep 13 2014 pinoc <vogtpet at gmail.com> 2.6.4-1pclos2014
- 2.6.4
- add patch and compiler config from MGA

* Thu May 09 2013 ghostbunny <hmhaase at pclinuxosusers dot de> 2.6.2-1pclos2013
- 2.6.2

* Sun Mar 04 2012 Neal <nealbrks0 at gmail dot com> 2.6.0-1pclos2012
- process

* Thu Feb 23 2012 leiche <meisssw01 at gmail.com> 2.6.0-1pclos2012
- 2.6.0
- add german description 

* Sat Oct 22 2011 Texstar <texstar at gmail.com> 2.4.4-1pclos2011
- 2.4.4
